import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
export interface DataAkeylessCertificateConfig extends cdktf.TerraformMetaArguments {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akeyless-community/akeyless/1.7.1/docs/data-sources/certificate#id DataAkeylessCertificate#id}
    *
    * Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
    * If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
    */
    readonly id?: string;
    /**
    * Retrieve the Secret value without checking the Gateway's cache [true/false]
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akeyless-community/akeyless/1.7.1/docs/data-sources/certificate#ignore_cache DataAkeylessCertificate#ignore_cache}
    */
    readonly ignoreCache?: string;
    /**
    * Certificate name
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akeyless-community/akeyless/1.7.1/docs/data-sources/certificate#name DataAkeylessCertificate#name}
    */
    readonly name?: string;
    /**
    * Certificate version
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akeyless-community/akeyless/1.7.1/docs/data-sources/certificate#version DataAkeylessCertificate#version}
    */
    readonly version?: number;
}
/**
* Represents a {@link https://registry.terraform.io/providers/akeyless-community/akeyless/1.7.1/docs/data-sources/certificate akeyless_certificate}
*/
export declare class DataAkeylessCertificate extends cdktf.TerraformDataSource {
    static readonly tfResourceType = "akeyless_certificate";
    /**
    * Generates CDKTF code for importing a DataAkeylessCertificate resource upon running "cdktf plan <stack-name>"
    * @param scope The scope in which to define this construct
    * @param importToId The construct id used in the generated config for the DataAkeylessCertificate to import
    * @param importFromId The id of the existing DataAkeylessCertificate that should be imported. Refer to the {@link https://registry.terraform.io/providers/akeyless-community/akeyless/1.7.1/docs/data-sources/certificate#import import section} in the documentation of this resource for the id to use
    * @param provider? Optional instance of the provider where the DataAkeylessCertificate to import is found
    */
    static generateConfigForImport(scope: Construct, importToId: string, importFromId: string, provider?: cdktf.TerraformProvider): cdktf.ImportableResource;
    /**
    * Create a new {@link https://registry.terraform.io/providers/akeyless-community/akeyless/1.7.1/docs/data-sources/certificate akeyless_certificate} Data Source
    *
    * @param scope The scope in which to define this construct
    * @param id The scoped construct ID. Must be unique amongst siblings in the same scope
    * @param options DataAkeylessCertificateConfig = {}
    */
    constructor(scope: Construct, id: string, config?: DataAkeylessCertificateConfig);
    get certificatePem(): string;
    private _id?;
    get id(): string;
    set id(value: string);
    resetId(): void;
    get idInput(): string | undefined;
    private _ignoreCache?;
    get ignoreCache(): string;
    set ignoreCache(value: string);
    resetIgnoreCache(): void;
    get ignoreCacheInput(): string | undefined;
    private _name?;
    get name(): string;
    set name(value: string);
    resetName(): void;
    get nameInput(): string | undefined;
    get privateKeyPem(): string;
    private _version?;
    get version(): number;
    set version(value: number);
    resetVersion(): void;
    get versionInput(): number | undefined;
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
    protected synthesizeHclAttributes(): {
        [name: string]: any;
    };
}
