import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
export interface TargetRabbitConfig extends cdktf.TerraformMetaArguments {
    /**
    * Description of the object
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akeyless-community/akeyless/1.7.1/docs/resources/target_rabbit#description TargetRabbit#description}
    */
    readonly description?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akeyless-community/akeyless/1.7.1/docs/resources/target_rabbit#id TargetRabbit#id}
    *
    * Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
    * If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
    */
    readonly id?: string;
    /**
    * Key name. The key will be used to encrypt the target secret value. If key name is not specified, the account default protection key is used
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akeyless-community/akeyless/1.7.1/docs/resources/target_rabbit#key TargetRabbit#key}
    */
    readonly key?: string;
    /**
    * Target name
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akeyless-community/akeyless/1.7.1/docs/resources/target_rabbit#name TargetRabbit#name}
    */
    readonly name: string;
    /**
    * RabbitMQ server password
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akeyless-community/akeyless/1.7.1/docs/resources/target_rabbit#rabbitmq_server_password TargetRabbit#rabbitmq_server_password}
    */
    readonly rabbitmqServerPassword?: string;
    /**
    * RabbitMQ server URI
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akeyless-community/akeyless/1.7.1/docs/resources/target_rabbit#rabbitmq_server_uri TargetRabbit#rabbitmq_server_uri}
    */
    readonly rabbitmqServerUri: string;
    /**
    * RabbitMQ server user
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akeyless-community/akeyless/1.7.1/docs/resources/target_rabbit#rabbitmq_server_user TargetRabbit#rabbitmq_server_user}
    */
    readonly rabbitmqServerUser: string;
}
/**
* Represents a {@link https://registry.terraform.io/providers/akeyless-community/akeyless/1.7.1/docs/resources/target_rabbit akeyless_target_rabbit}
*/
export declare class TargetRabbit extends cdktf.TerraformResource {
    static readonly tfResourceType = "akeyless_target_rabbit";
    /**
    * Generates CDKTF code for importing a TargetRabbit resource upon running "cdktf plan <stack-name>"
    * @param scope The scope in which to define this construct
    * @param importToId The construct id used in the generated config for the TargetRabbit to import
    * @param importFromId The id of the existing TargetRabbit that should be imported. Refer to the {@link https://registry.terraform.io/providers/akeyless-community/akeyless/1.7.1/docs/resources/target_rabbit#import import section} in the documentation of this resource for the id to use
    * @param provider? Optional instance of the provider where the TargetRabbit to import is found
    */
    static generateConfigForImport(scope: Construct, importToId: string, importFromId: string, provider?: cdktf.TerraformProvider): cdktf.ImportableResource;
    /**
    * Create a new {@link https://registry.terraform.io/providers/akeyless-community/akeyless/1.7.1/docs/resources/target_rabbit akeyless_target_rabbit} Resource
    *
    * @param scope The scope in which to define this construct
    * @param id The scoped construct ID. Must be unique amongst siblings in the same scope
    * @param options TargetRabbitConfig
    */
    constructor(scope: Construct, id: string, config: TargetRabbitConfig);
    private _description?;
    get description(): string;
    set description(value: string);
    resetDescription(): void;
    get descriptionInput(): string | undefined;
    private _id?;
    get id(): string;
    set id(value: string);
    resetId(): void;
    get idInput(): string | undefined;
    private _key?;
    get key(): string;
    set key(value: string);
    resetKey(): void;
    get keyInput(): string | undefined;
    private _name?;
    get name(): string;
    set name(value: string);
    get nameInput(): string | undefined;
    private _rabbitmqServerPassword?;
    get rabbitmqServerPassword(): string;
    set rabbitmqServerPassword(value: string);
    resetRabbitmqServerPassword(): void;
    get rabbitmqServerPasswordInput(): string | undefined;
    private _rabbitmqServerUri?;
    get rabbitmqServerUri(): string;
    set rabbitmqServerUri(value: string);
    get rabbitmqServerUriInput(): string | undefined;
    private _rabbitmqServerUser?;
    get rabbitmqServerUser(): string;
    set rabbitmqServerUser(value: string);
    get rabbitmqServerUserInput(): string | undefined;
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
    protected synthesizeHclAttributes(): {
        [name: string]: any;
    };
}
